;----------------------------------------------------------------------------

; ⥫ , N, ਮ, ⥫쭮, ᪢    Atmel 89c2051

; Copyright (c)	1997-1998 by DN

;  3

;----------------------------------------------------------------------------

; :

; Ŀ
;  Ŀ	Ŀ Ŀ	Ŀ Ŀ	Ŀ Ŀ	Ŀ Ŀ	Ŀ 
;  Ĵ	Ĵ Ĵ	Ĵ Ĵ	Ĵ Ĵ	Ĵ Ĵ	Ĵ 
;  	 	 	 	 	 
; 

; 
;  ࠡ ਡ:
;
;  F: Timer1  TF1    1 ᥪ㭤,
; ନ㥬 ணࠬ
;
;  N: Timer0, R6  R7  
;
;  T,tau: Timer0, R6  R7   ⮩ 1  
; ६ ᫥ 譥 ਮ/
;
;  Q: 塞 ਮ  ⥫쭮, ⮬ ⠥ ⭮襭
;


; ଠ  : <訩 >...<訩	>

;----------------------------------------------------------------------------

;FQ	=	12000000	;  ⠪⮢ ,	

SERIALN	=       2048-10		;  ப ਩ 

;----------------------------------------------------------------------------

; 譨 ᨣ

; 室

MODE_SW =	P3.3	;  ४祭 ० ࠡ

SHIFT	=	P1.4	; ४⥫	"ᤢ 祪"
RES0	=	P1.5	;  ". 0"

; 室

BL0	=	P3.0	; ஢ ࢮ "-"
BL1	=	P3.1	; ஢ ண "-"
DIV2	=	P1.2	; ४⥫ ਮ/⥫쭮
POS_NEG	=	P1.3	; ४⥫ ⥫쭮/⥫쭮 ୮

DAT	=	P1.7	;   
CLK	=	P1.6	; ஭	 

TXDATA	=	P3.7	; ।   

; ⠭

SIGN_SPACE	=	0
SIGN_F		=	0Dh
SIGN_J		=	3
SIGN_L		=	0Bh
SIGN_P		=	7
SIGN_MINUS	=	0Fh

;----------------------------------------------------------------------------

;  

dstart	rseg	DATA

flags	=	2Fh		; 	ணࠬ
DELTA		=	flags.0		;  ७ ⪫
SIGN		=	flags.1		;   ७ ⪫
OVERFLOW	=	flags.2		; ९
MODE_CHANGED	=	flags.3		; 뫠   ४. ०
F_1S		=	flags.4		;   ६ ⬥塞 1 ᥪ㭤

	org	dstart+30h

mode	ds	1	; 	ࠡ

MODE_F		=	0
MODE_T		=	1
MODE_TAUPOS 	=	2
MODE_TAUNEG 	=	3
MODE_QPOS 	=	4
MODE_QNEG 	=	5
MODE_NPOS	=	6
MODE_NNEG	=	7

MODES	=	8

bin_buf	ds	4		;  筮 ।⠢ 
oldb_buf ds	4		; ஥ 祭 稪

dec_buf	ds	10		;  
lcd_buf	ds	10		; 	

t1_c	ds	3	; ন 稪 Timer1 ᫥  ( . ⮬)
rest_count	ds	2	; ⮪  譥 ।⥫


;  ஡ :

dividend	ds	8	;  - 訥 4 
divider		ds	4	; ⥫
quotient	ds	8	; ⭮ - 訥 4  - 楫 ,
				;           訥 4  - ஡ 

int_digits	ds	1	; - 楫    ⭮

;----------------------------------------------------------------------------

;  

start	rseg CODE

	org	start	; 	᫥ 
	jmp	real_start

	org	start+0Bh	; 뢠 	Timer0
	jmp	timer0_handler

	org	start+13h	; 뢠 	Int1 - ४祭 ०
	setb	MODE_CHANGED	;  ० - 㦭 ४

	jnb	F_1S,int1_exit	;  ० F 室  ,
	mov	r1,#1		;   ᥪ㭤.
	mov	r2,#1		; ⮬ ᪮ਬ 

int1_exit:
	reti

timer0_handler:
	push	psw
	inc	r6
	cjne	r6,#0,timer0_exit
	inc	r7
timer0_exit:
	pop	psw
	reti

;----------------------------------------------------------------------------

; ᭮ ணࠬ

	db	13,10,13,10
	db	'Frequency Counter by DN',13,10
	db	'Version 3',13,10
	db	13,10

real_start:

	clr	EA	; 頥 뢠
	mov	sp,#7	; 樠㥬 㪠⥫ ⥪

	call	serialn_out	; 뢠 ਩ 

	mov	mode,#MODE_F

warm_start:
	mov	oldb_buf,#0	; 頥   祭
	mov	oldb_buf+1,#0
	mov	oldb_buf+2,#0
	mov	oldb_buf+3,#0

	clr	EA
	mov	sp,#7
	mov	flags,#0

	mov	a,mode	;  ᨬ  ० ࠡ - 室

	cjne	a,#MODE_F,not_modef	;  F
	jmp	mode_f

not_modef:
	cjne	a,#MODE_NPOS,not_modenpos	;  NPOS
	clr	POS_NEG		; ⥫ 
	jmp	mode_n
	
not_modenpos:
	cjne	a,#MODE_NNEG,not_modenneg	;  NNEG
	setb	POS_NEG		; ⥫ 
	jmp	mode_n

not_modenneg:
	cjne	a,#MODE_T,not_modet	;  T
	setb	DIV2	; ४⥫ - ᫥ ਣ
	clr	POS_NEG		; ⥫ 
	jmp	mode_ttau

not_modet:
	cjne	a,#MODE_TAUPOS,not_modetaupos	;  TAUNEG
	clr	DIV2	; ४⥫ -  ਣ
	clr	POS_NEG		; ⥫ 
	jmp	mode_ttau

not_modetaupos:
	cjne	a,#MODE_TAUNEG,not_modetauneg	;  TAUPOS
	clr	DIV2	; ४⥫ -  ਣ
	setb	POS_NEG		; ⥫ 
	jmp	mode_ttau

not_modetauneg:
	cjne	a,#MODE_QPOS,not_modeqpos	;  QPOS
	clr	POS_NEG		; ⥫ 
	jmp	mode_q

not_modeqpos:
						;  QNEG
	setb	POS_NEG		; ⥫ 
	jmp	mode_q

;----------------------------------------------------------------------------

; 	७ 

mode_f:

; p. p

	clr	BL0	; 㥬 㯫	ᮢ
	setb	BL1

	mov	tmod,#01010001b	;  ⠩஢:16-
				; Timer1 - 稪

	mov	tcon,#01000100b	; p襭 Timer1
	mov	ie,#10000100b
	mov	flags,#0	; 	䫠

; ⪠ 譥 ।⥫

	mov     th1,#0FFh		; Timer1 = 0FFFFh
	mov     tl1,#0FFh
	clr	TF1

ec_clear:
	clr	BL1	;    譨 ।⥫
	setb	BL1
	jnb	TF1,ec_clear	;   

; ᭮ 横 

f_loop:

	setb	F_1S	;  - 砫 ⬥ 1 

	clr	TF1
	setb	BL0	; 蠥 宦	ᨣ	१  

	mov	r1,#230	; OK
	mov	r2,#172	; OK

; ନ㥬 প - 1 ᥪ.

delay1s_loop:

; ࠭   12 

	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop

	djnz	r2,delay1s_loop
	djnz	r1,delay1s_loop

	nop
	nop
	nop
	nop
	nop

	clr	BL0

;  祭.	 ⮬ ﭨ BL1==1, BL0==0

	clr	F_1S	; 稫 ⬥ 1 

; ᫨ 㦭, 砥 ० ७ ⪫

	jb	RES0,f_notpressed
	setb	DELTA
f_notpressed:

	call	mode_switcher	;  ४祭 ० ࠡ

	mov	t1_c+2,tl1		; ﭨ ⠩ timer1
	mov	t1_c+1,th1

	mov	t1_c,#0
	jnb	TF1,not_tf1	;  ९ = ⥫ 
	inc	t1_c
not_tf1:

;  ᫠,	⠢襣  譥 稪

	mov	rest_count,#high(512+1)	; 稪 ⪠ <- 512+1
	mov	rest_count+1,#low(512+1)

	mov	th1,#0FFh		; timer1 <- 0FFFFh ( ९)
	mov	tl1,#0FFh
	clr	TF1

wait_timer1_overflow:
	clr	BL1	;  BL1 -	। 
	setb	BL1
	djnz	rest_count+1,rc_nohibyte
	dec	rest_count
rc_nohibyte:

	mov	a,rest_count	; ਩ 室, ᫨	ࢠ ஢
	inc	a
	jz	rc_cted

	jnb	TF1,wait_timer1_overflow	;  ९ timer1

rc_cted:
	dec rest_count+1

;   t1_c	(3) - ⢮ ᮢ, ⠭ 稪 Timer1+TF1
;		     㦭 㬭  512
;	  rest_count (2) - ⮪ 譥 ।⥫

;  ६頥 	   	⮬ 㬭  512

	clr	c	;  t1_c	   (*2)
	mov	a,t1_c+2
	rlc	a
	mov	bin_buf+2,a
	mov	a,t1_c+1
	rlc	a
	mov	bin_buf+1,a
	mov	a,t1_c
	rlc	a
	mov	bin_buf,a

	mov	bin_buf+3,rest_count+1	;  訥  ᫠
	mov	a,rest_count
	orl	bin_buf+2,a

;   bin_buf 室 4-⮢	᫮ -	祭 稪

	jb DELTA,do_delta	;  砥 ० F - 塞	 

	mov	oldb_buf,bin_buf
	mov	oldb_buf+1,bin_buf+1
	mov	oldb_buf+2,bin_buf+2
	mov	oldb_buf+3,bin_buf+3

	jmp	cn_done

do_delta:
	call	process_delta	;  ० Delta F - ⠥ ࠧ 

cn_done:

	call	make_decbuf	; bin_buf -> dec_buf

;	call	dump_decbuf

	call	make_lcdbuf	; dec_buf -> lcd_buf
	call	display_lcd	; 뢮  ࠭
	call	display_rs232	; 뢮   RS232

	jmp	f_loop

;----------------------------------------------------------------------------

; 	७ N - ⢠ ᮢ

mode_n:

	clr	EA

	mov	ip,#00000010b	; p pp⮢ Timer0-訩
	mov	ie,#10000110b	; 蠥 뢠  Timer0
	mov	tmod,#00000101b	; Timer0 - 16- 稪
	mov	tcon,#00010100b	; 砥 Timer0
	
	setb	BL1
	setb	BL0	; 蠥 㯫	ᮢ

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	mov	bin_buf,a
	mov	bin_buf+1,a
	mov	bin_buf+2,a
	mov	bin_buf+3,a

	mov	flags,#0

moden_loop:
	call	make_decbuf	;   -> 
;	call	dump_decbuf
	call	make_lcdbuf
	call	display_lcd	; 뢮  ࠭
	call	display_rs232	; 뢮   RS232

	mov	r1,#60		; প , ⮡ .  栫
	mov	r2,#0

nm_l1:

	call	mode_switcher	;  ४祭 ० ࠡ
	jnb	RES0,mode_n	;    RES0?

	djnz	r2,nm_l1
	djnz	r1,nm_l1

nm_again:
	mov	bin_buf,r7	;  稪 -  
	mov	bin_buf+1,r6
	mov	bin_buf+2,th0
	mov	bin_buf+3,tl0

	mov	a,r7			; ஢塞 ᮮ⢥⢨  
	cjne	a,bin_buf,nm_again	;     
	mov	a,r6
	cjne	a,bin_buf+1,nm_again
	mov	a,th0
	cjne	a,bin_buf+2,nm_again

	jmp	moden_loop

;----------------------------------------------------------------------------

;  ७ T - ਮ, tau	- ⥫쭮 ᮢ

mode_ttau:
	clr	EA
	mov	ip,#00000010b	; p pp⮢ Timer0-訩
	mov	ie,#10000110b	; 蠥 뢠  Timer0
	mov	tmod,#00001001b	; Timer0 - 16- ⠩
	mov	tcon,#00010100b	; 砥 Timer0

	setb	BL0
	setb	BL1

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	mov	flags,#0

ttau_reset:

	clr	TR0
	mov	bin_buf,r7	;  稪 -  
	mov	bin_buf+1,r6
	mov	bin_buf+2,th0
	mov	bin_buf+3,tl0

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	setb	TR0

	clr	BL0	; 뢠 ନ஢⥫ ᮢ
	setb	BL0

ttau_loop:
	jb	DELTA,ttau_dontstore	;  ०  ⪫  
					;  
	mov	oldb_buf,bin_buf
	mov	oldb_buf+1,bin_buf+1
	mov	oldb_buf+2,bin_buf+2
	mov	oldb_buf+3,bin_buf+3

; mov oldb_buf,#0
; mov oldb_buf+1,#0
; mov oldb_buf+2,#0
; mov oldb_buf+3,#0

ttau_dontstore:
	jnb	DELTA,ttau_bufok
	call	process_delta		;  ० ⪫ ࠧࠥ  

ttau_bufok:

;mov bin_buf,#0
;mov bin_buf+1,#0
;mov bin_buf+2,#0
;mov bin_buf+3,#0

	call	make_decbuf	;   -> 
	call	make_lcdbuf
	call	display_lcd	; 뢮  ࠭
	call	display_rs232	; 뢮   RS232

	mov	r1,#100		; প , ⮡ .  栫
	mov	r2,#0
ttau_wait:
	call	mode_switcher	;  ४祭 ० ࠡ
	djnz	r2,ttau_wait
	djnz	r1,ttau_wait

	jb	RES0,ttau_notpressed	;  ⨨ RES0 砥
	setb	DELTA			; ० ७ ⪫
ttau_notpressed:

	jb	INT0,ttau_loop	; ᫨    - ⠥ 

	jmp	ttau_reset

;----------------------------------------------------------------------------

;  ७ Q - ᪢

mode_q:

	clr	EA
	mov	ip,#00000010b	; p pp⮢ Timer0-訩
	mov	tmod,#00001001b	; Timer0 - 16- ⠩
	mov	tcon,#00010100b	; 砥 Timer0
	mov	ie,#10000110b	; 蠥 뢠  Timer0

	clr	BL0
	setb	BL0
	setb	BL1

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	mov	flags,#0

        mov     dividend+4,#0   ; 砫 - 㫨    ⥫
        mov     dividend+5,#0
        mov     dividend+6,#0
        mov     dividend+7,#0

        mov     divider,#0
        mov     divider+1,#0
        mov     divider+2,#0
        mov     divider+3,#0

; 塞 ਮ

mq_dot:
	setb	DIV2		; 砥 ⥫  2

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	setb	TR0

	clr	BL0	; 뢠 ନ஢⥫ ᮢ
	setb	BL0

mqt_loop:

	call	make_lcdq	;   
	call	display_lcd	; 뢮  ࠭
	call	display_rs232	; 뢮   RS232

	mov	r1,#100		; প , ⮡ .  栫
	mov	r2,#0
mqt_wait:
	call	mode_switcher	;  ४祭 ० ࠡ
	djnz	r2,mqt_wait
	djnz	r1,mqt_wait

	jb	INT0,mqt_loop	; ᫨    - ⠥ 

	clr	TR0
	mov	dividend+4,r7	;  稪 -   
	mov	dividend+5,r6
	mov	dividend+6,th0
	mov	dividend+7,tl0

; 塞 ⥫쭮

mq_dotau:
	clr	DIV2		; 몫砥 ⥫  2

	clr	a
	mov	tl0,a		; 頥 稪  ⥫
	mov	th0,a
	mov	r6,a
	mov	r7,a

	setb	TR0

	clr	BL0	; 뢠 ନ஢⥫ ᮢ
	setb	BL0

mqtau_loop:

	call	make_lcdq	;   
	call	display_lcd	; 뢮  ࠭
	call	display_rs232	; 뢮   RS232

	mov	r1,#100		; প , ⮡ .  栫
	mov	r2,#0
mqtau_wait:
	call	mode_switcher	;  ४祭 ० ࠡ
	djnz	r2,mqtau_wait
	djnz	r1,mqtau_wait

	jb	INT0,mqtau_loop	; ᫨    - ⠥ 

	clr	TR0
	mov	divider,r7	;  稪 -   ⥫
	mov	divider+1,r6
	mov	divider+2,th0
	mov	divider+3,tl0

	clr	OVERFLOW
	call	frac_div	; ஡ 
        jb      OVERFLOW,mq_next
	call	frac_dec	; ॢ   

mq_next:
        jmp     mq_dot          ;   塞 ਮ

;----------------------------------------------------------------------------

; ४祭 ० ࠡ

mode_switcher:

	jnb	MODE_CHANGED,ms_exit	; ᫨ ०  ,  ४砥

	clr	EA
	mov	ie,#0

	call	display_mode

	mov	r1,#0	; ஥ ६ 뢠 ⥪騩 ०
	mov	r2,#0	;  ६  প  ॡ

ms_wait0:
;	nop
	nop
	nop
	nop
	nop
	nop
	nop
	djnz	r2,ms_wait0
	djnz	r1,ms_wait0


ms_again:
	mov	r1,#0	; ᫨   - ४砥
	mov	r1,#0

ms_wait:
	jnb	MODE_SW,ms_nextmode	; ᫨   - ४砥
	jnb	RES0,ms_prevmode	; ᫨  RES0 - 
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	djnz	r2,ms_wait
	djnz	r1,ms_wait

	jmp	warm_start		; 稭 ࠡ

ms_nextmode:

	mov	a,mode		; 砥 ᫥騩 ०
	inc	a
	cjne	a,#MODES,ms_dm
;	clr	a
	mov	a,#MODES-1
	jmp	ms_dm

ms_prevmode:

	mov	a,mode
	dec	a
	cjne	a,#255,ms_dm
;	mov	a,#MODES-1
	mov	a,#0

ms_dm:
	mov	mode,a
	call	display_mode

	mov	r1,#0		; ᫥ ४祭 -  প
	mov	r2,#0		;   ॡ
ms_wait1:
	nop
	nop
	nop
	djnz	r2,ms_wait1
	djnz	r1,ms_wait1

	jmp	ms_again

ms_exit:
	ret

;----------------------------------------------------------------------------

; ࠥ  ० ७ ⪫

process_delta:

; 塞 ࠧ  稪 ᥩ  ࠭

	clr	c		; ࠢ 4 
	mov	r2,#4
	mov	r0,#bin_buf+3
	mov	r1,#oldb_buf+3

compare_next:
	mov	a,@r0
	subb	a,@r1
	dec	r0
	dec	r1
	djnz	r2,compare_next

; 室 p 

	mov	SIGN,c	;  ७
	mov	r2,#4
	mov	r0,#bin_buf+3
	mov	r1,#oldb_buf+3
	jc	going_down	;  ᨬ	 ࠢ 室 

;   

going_up:

	clr	c ;*

gu_next:

	mov	a,@r0
	subb	a,@r1
	mov	@r0,a
	dec	r0
	dec	r1
	djnz	r2,gu_next	;  	4- ᥫ
	jmp    pd_exit		; ࠥ 	१⮬

;   

going_down:

	clr	c

gd_next:
	mov	a,@r1
	subb	a,@r0
	mov	@r0,a
	dec	r0
	dec	r1
	djnz	r2,gd_next	 ;p 4 p

pd_exit:
	ret

;----------------------------------------------------------------------------

; 	㯠 ।⠢ ->  

; bin_buf - 4 
; dec_buf - 10  

make_decbuf:

	mov	r1,#8
	mov	r0,#dec_buf+7

mdb_next:
	call	div_10	; 	ᮤন bin_buf  10
	mov	@r0,a	; ⮪ - ।  (	 	砫)
	dec	r0
	djnz	r1,mdb_next

	clr	a		; ஢塞  ९
	cjne	a,bin_buf,mdb_ov
	cjne	a,bin_buf+1,mdb_ov
	cjne	a,bin_buf+2,mdb_ov
	cjne	a,bin_buf+3,mdb_ov
	jmp	mdb_exit	; ९ 

mdb_ov:
	setb	OVERFLOW	; -⠪ ९

mdb_exit:
	ret

;----------------------------------------------------------------------------

;  4-⭮  bin_buf  10

div_10:

	mov	r3,#32	; 4  = 32 
	mov	r4,#0	;  r4 㤥 室	⮪
	clr	c

d10_next:

	mov	a,bin_buf+3	;   + r4  1  
	rlc	a
	mov	bin_buf+3,a
	mov	a,bin_buf+2
	rlc	a
	mov	bin_buf+2,a
	mov	a,bin_buf+1
	rlc	a
	mov	bin_buf+1,a
	mov	a,bin_buf
	rlc	a
	mov	bin_buf,a
	mov	a,r4
	rlc	a
	mov	r4,a

	clr	c	; ᫨  10 - ⠥ 10
	subb	a,#10
	cpl	c
	jnc	d10_lower
	mov	r4,a
d10_lower:

	djnz	r3,d10_next

	mov	a,bin_buf+3	;   ᤢ 
	rlc	a
	mov	bin_buf+3,a
	mov	a,bin_buf+2
	rlc	a
	mov	bin_buf+2,a
	mov	a,bin_buf+1
	rlc	a
	mov	bin_buf+1,a
	mov	a,bin_buf
	rlc	a
	mov	bin_buf,a

	mov	a,r4

	ret
;----------------------------------------------------------------------------

; ॢ   ⥬ ஡ ᫠

; quotient -> dec_buf
;  int_digits - ⢮   楫  ᫠

frac_dec:

; ࠥ  楫 

	mov	bin_buf,quotient	;   -  bin_buf
	mov	bin_buf+1,quotient+1
	mov	bin_buf+2,quotient+2
	mov	bin_buf+3,quotient+3

	mov	r1,#10
	mov	r0,#dec_buf+9

fdc_next:
	call	div_10	; 	ᮤন bin_buf  10
	mov	@r0,a	; ⮪ - ।  (	 	砫)
	dec	r0
	djnz	r1,fdc_next

; ⠥ -    楫 

	mov	r0,#dec_buf
	mov	r1,#10

fdc_idnext:
	mov	a,@r0
	jnz	fdc_idexit
	inc	r0
	djnz	r1,fdc_idnext

fdc_idexit:
	mov	a,r1	; ᫨  -  㤥 1
	jnz	fdc_idwr
	mov	a,#1

fdc_idwr:
	mov	int_digits,a	;   int_digits - ᫮ 楫 

; ࠥ  ஡  ᫠

	mov	bin_buf,quotient+4
	mov	bin_buf+1,quotient+5
	mov	bin_buf+2,quotient+6
	mov	bin_buf+3,quotient+7

;mov bin_buf,#128
;mov bin_buf+1,#0
;mov bin_buf+2,#0
;mov bin_buf+3,#0

	mov	a,#9		; ⠥, ᪮쪮 㦭 ஡ 
	clr	c
	subb	a,int_digits
	mov	r1,a	; ᫮ ஡ 
	jz	fdc_exit	; ᫨   - 室

;  dec_buf, ⮡ 楫  뫠 ᫥

	mov	r2,a
	inc	r2
;	mov	r2,#2

fdc_snext:
	mov	dec_buf,dec_buf+1
	mov	dec_buf+1,dec_buf+2
	mov	dec_buf+2,dec_buf+3
	mov	dec_buf+3,dec_buf+4
	mov	dec_buf+4,dec_buf+5
	mov	dec_buf+5,dec_buf+6
	mov	dec_buf+6,dec_buf+7
	mov	dec_buf+7,dec_buf+8
	mov	dec_buf+8,dec_buf+9
	mov	dec_buf+9,#0

	djnz	r2,fdc_snext

; jmp fdc_exit

	mov	a,#dec_buf
	add	a,int_digits
	mov	r0,a	; 㤠   dec_buf

; ॢ   ⥬ ஡ 

;mov r0,#dec_buf+3
;mov r1,#7

fdc_fnext:
	mov	b,#10
	mov	a,bin_buf+3
	mul	ab
	mov	bin_buf+3,a
	mov	r2,b

	mov	b,#10
	mov	a,bin_buf+2
	mul	ab
	add	a,r2
	mov	bin_buf+2,a
	mov	a,#0
	addc	a,b
	mov	r2,a
;	mov	r2,b

	mov	b,#10
	mov	a,bin_buf+1
	mul	ab
	add	a,r2
	mov	bin_buf+1,a
	mov	a,#0
	addc	a,b
	mov	r2,a
;	mov	r2,b

	mov	b,#10
	mov	a,bin_buf
	mul	ab
	add	a,r2
	mov	bin_buf,a
	mov	a,#0
	addc	a,b
;	mov	a,b

	mov	@r0,a
	inc	r0	

	djnz	r1,fdc_fnext

fdc_exit:
	ret

;----------------------------------------------------------------------------

; ஡  dividend  divider -> quotient

frac_div:

	mov	a,divider	; ஢塞    
	jnz	fd_start
	mov	a,divider+1
	jnz	fd_start
	mov	a,divider+2
	jnz	fd_start
	mov	a,divider+3
	jnz	fd_start

	; ࠥ  । 0:0  -  㤥 1

	mov	a,dividend+4
	jnz	fd_ov
	mov	a,dividend+5
	jnz	fd_ov
	mov	a,dividend+6
	jnz	fd_ov
	mov	a,dividend+7
	jnz	fd_ov

	mov	quotient,#0	; ⢥  
	mov	quotient+1,#0
	mov	quotient+2,#0
	mov	quotient+3,#1
	mov	quotient+4,#0
	mov	quotient+5,#0
	mov	quotient+6,#0
	mov	quotient+7,#0
	jmp	fd_exit

fd_ov:
	setb	OVERFLOW	; ਧ ९
	jmp	fd_exit

fd_start:
	mov	r2,#64	; -  १

	mov	dividend,#0	; 訥 4   塞
	mov	dividend+1,#0
	mov	dividend+2,#0
	mov	dividend+3,#0

fd_next:
	mov	a,dividend+7	;    1  
	clr	c
	rlc	a
	mov	dividend+7,a
	mov	a,dividend+6
	rlc	a
	mov	dividend+6,a
	mov	a,dividend+5
	rlc	a
	mov	dividend+5,a
	mov	a,dividend+4
	rlc	a
	mov	dividend+4,a
	mov	a,dividend+3
	rlc	a
	mov	dividend+3,a
	mov	a,dividend+2
	rlc	a
	mov	dividend+2,a
	mov	a,dividend+1
	rlc	a
	mov	dividend+1,a
	mov	a,dividend
	rlc	a
	mov	dividend,a

	clr	c		;  ࠢ 訥 4  
	mov	a,dividend+3	;  ⥫
	subb	a,divider+3
	mov	a,dividend+2
	subb	a,divider+2
	mov	a,dividend+1
	subb	a,divider+1
	mov	a,dividend
	subb	a,divider
	cpl	c

;  䫠 C ᮤন 1, ᫨ 4 .    ⥫

	jnc	fd_q

; ⠥  4    ⥫
	
	clr	c
	mov	a,dividend+3
	subb	a,divider+3
	mov	dividend+3,a

	mov	a,dividend+2
	subb	a,divider+2
	mov	dividend+2,a

	mov	a,dividend+1
	subb	a,divider+1
	mov	dividend+1,a

	mov	a,dividend
	subb	a,divider
	mov	dividend,a

	setb	c

fd_q:
	mov	a,quotient+7	; 襬 १  ⭮,  ᤢ  
	rlc	a
	mov	quotient+7,a
	mov	a,quotient+6
	rlc	a
	mov	quotient+6,a
	mov	a,quotient+5
	rlc	a
	mov	quotient+5,a
	mov	a,quotient+4
	rlc	a
	mov	quotient+4,a
	mov	a,quotient+3
	rlc	a
	mov	quotient+3,a
	mov	a,quotient+2
	rlc	a
	mov	quotient+2,a
	mov	a,quotient+1
	rlc	a
	mov	quotient+1,a
	mov	a,quotient
	rlc	a
	mov	quotient,a

	djnz	r2,fd_next1	;  ⠪  ᥬ 64 ⠬...

fd_exit:
	ret

fd_next1:
	jmp	fd_next

;----------------------------------------------------------------------------

;   ->  

; dec_buf - 8 ᥫ
; lcd_buf -  ⮢   , 10 

; xx xxx xxx  -	 ० /1	 -  ० ७ F
; xxx xxx xx  -	 ० /10	 -

; 	७ Delta	F -  ࢮ 	 ⪫
; ᫨  ࠧ   - 塞  ᠬ -	९

make_lcdbuf:

	mov	r1,#lcd_buf	; 塞   ஡
	mov	r2,#10
mb_spacefill:
	mov	@r1,#SIGN_SPACE
	inc	r1
	djnz	r2,mb_spacefill

	mov	dptr,#tran_table	;  ᨬ 

	jb	DELTA,mb_delta

	;  ० 筮 ७ 

	mov	a,dec_buf	;  ࠧ
	jz	mb_all
	movc	a,@a+dptr	; ᫨  ,	 	
	mov	lcd_buf,a
	mov	a,dec_buf+1	; ன ࠧ
	jmp	mb_do2

mb_delta:

	;  ० ७ ⪫

	mov	a,dec_buf	;  ࠧ
	jnz	mb_error
	jmp	mb_dnoerr

mb_error:
	;  ࠧ	 ७ ⪫ -  , 訡
	mov	r1,#lcd_buf	; 塞   ᠬ
	mov	r2,#10
mb_errfill:
	mov	@r1,#SIGN_MINUS
	inc	r1
	djnz	r2,mb_errfill
	jmp	mb_exit

mb_dnoerr:
	mov	lcd_buf,#SIGN_P	 ;  ᨬ   -  ࠧ
	jnb	SIGN,mb_all
	mov	lcd_buf,#SIGN_MINUS

mb_all:
	; ⠫ ࠧ

	mov	a,dec_buf+1	; ன ࠧ
	jnz	mb_do2
	mov	a,dec_buf+2	; ⢥ ࠧ
	jnz	mb_do4
	mov	a,dec_buf+3	; 	ࠧ
	jnz	mb_do5
	mov	a,dec_buf+4	; ⮩ ࠧ
	jnz	mb_do6
	mov	a,dec_buf+5	; 쬮 ࠧ
	jnz	mb_do8
	mov	a,dec_buf+6	;  ࠧ
	jnz	mb_do9
	mov	a,dec_buf+7
	jmp	mb_do10

mb_do2:
	movc	a,@a+dptr	; ன ࠧ	 ⮩
	mov	lcd_buf+1,a
	mov	a,dec_buf+2
mb_do4:
	movc	a,@a+dptr	; ⢥ ࠧ  ⮩
	mov	lcd_buf+3,a
	mov	a,dec_buf+3
mb_do5:
	movc	a,@a+dptr	; 	ࠧ  ⮩
	mov	lcd_buf+4,a
	mov	a,dec_buf+4
mb_do6:
	movc	a,@a+dptr	; ⮩ ࠧ	 ⮩
	mov	lcd_buf+5,a
	mov	a,dec_buf+5
mb_do8:
	movc	a,@a+dptr	; 쬮 ࠧ  ⮩
	mov	lcd_buf+7,a
	mov	a,dec_buf+6
mb_do9:
	movc	a,@a+dptr	;  ࠧ  ⮩
	mov	lcd_buf+8,a
	mov	a,dec_buf+7
mb_do10:
	movc	a,@a+dptr	;  ࠧ
	mov	lcd_buf+9,a

	;    

	jb	SHIFT,mb_exit	; 㦭	 ᤢ ?
	mov	a,mode
	cjne	a,#MODE_F,mb_exit

	;  
	;    xx xxx xxx
	; 㤥	   xxx xxx xx

	mov	lcd_buf+2,lcd_buf+3
	mov	lcd_buf+6,lcd_buf+7
	mov	lcd_buf+3,#SIGN_SPACE
	mov	lcd_buf+7,#SIGN_SPACE

mb_exit:

	ret

;----------------------------------------------------------------------------

; ࠦ ⥪饣 ० ࠡ  

display_mode:
	mov	r0,#10
	mov	r1,#lcd_buf
	mov	a,mode
	inc	a
	add	a,#lcd_buf
dm_clr:
	mov	@r1,#SIGN_SPACE
	cjne	a,1,dm_notthis
	mov	@r1,#SIGN_MINUS
dm_notthis:

	inc	r1
	djnz	r0,dm_clr

	call	display_lcd	; 뢮  ࠭

	ret

;----------------------------------------------------------------------------

; 뢮	  	 

display_lcd:

	jnb	OVERFLOW,disp_noover	;  ९ 뢮 ન
	clr	OVERFLOW

	mov	r2,#10			; 뢮 ન
disp_o:
	mov	a,#SIGN_MINUS
	call	display_digit
	djnz	r2,disp_o
	jmp	disp_exit

disp_noover:
	mov	r1,#lcd_buf		; 뢮 ᮤন  
	mov	r2,#10
disp_next:
	mov	a,@r1
	call	display_digit
	inc	r1
	djnz	r2,disp_next

disp_exit:
	clr	DAT

	ret

;----------------------------------------------------------------------------

; 뢮	   ᨬ  ACC

display_digit:
	mov	r3,#4

disp_next_bit:
	rrc	a
	mov	DAT,c	; ⠢塞 
	nop
	nop
	setb	CLK	;  CLK
	nop
	nop
	clr	CLK
	nop
	nop

	djnz	r3,disp_next_bit

	ret

;----------------------------------------------------------------------------

; 뢮  RS-232 ᮤন  

display_rs232:

	mov	r0,mode		;  ᨬ  ० 뢮 
	inc	r0
	mov	dptr,#names_table-NAME_LEN

dr_addlen:
	mov	a,#NAME_LEN
	add	a,dpl
	mov	dpl,a
	mov	a,#0
	addc	a,dph
	mov	dph,a
	djnz	r0,dr_addlen

	mov	r1,#NAME_LEN
dr_nextname:
	clr	a
	movc	a,@a+dptr
	call	rs232_sendbyte
	inc	dptr
	djnz	r1,dr_nextname

	jnb	OVERFLOW,dr_noover	;  ९ 뢮 ન
	clr	OVERFLOW

	mov	r2,#10			; 뢮 ન
dr_o:
	mov	a,#'-'
	call	rs232_sendbyte
	djnz	r2,dr_o
	jmp	dr_exit

dr_noover:
	mov	r1,#lcd_buf		; 뢮 ᮤন  
	mov	r2,#10
	mov	dptr,#lcd2ascii_table
dr_next:
	mov	a,@r1
	movc	a,@a+dptr
	call	rs232_sendbyte
	inc	r1
	djnz	r2,dr_next

dr_exit:

	mov	a,#13		; 뢮 ᫥⥫쭮 CR, LF
	call	rs232_sendbyte
	mov	a,#10
	call	rs232_sendbyte

	ret

;----------------------------------------------------------------------------

; 뢮   RS-232

rs232_sendbyte:

	clr	TXDATA		; ⮢ 
	call	delay_1bit

	mov	r3,#8		; 

rs232s_next:
	rrc	a
	mov	TXDATA,c
	call	delay_1bit
	djnz	r3,rs232s_next

	setb	TXDATA		; ⮯ 
	call	delay_1bit

	ret

;----------------------------------------------------------------------------

; প  1  ।   ᪮ 1200 

delay_1bit:
	mov	r4,#170
d1b_wait:
	nop
	nop
	nop
	djnz	r4,d1b_wait

	ret

;----------------------------------------------------------------------------

;  ४஢	 ७ ।⠢   LCD

tran_table:
	db	05h,08h,04h,0Ch,02h,0Ah,06h,0Eh,01h,09h	; '0123456789'
	db	00h,0Dh,03h,0Bh,07h,0Fh			; ' FLJP-'

;  ४஢   LCD  ASCII

lcd2ascii_table:
	db	' ','8','4','','2','0','6','P','1','9'
	db	'5','','3','F','7','-'

;  ப  祭 ࠧ ०

names_table:

	db	'F    : '
	db	'N+   : '
	db	'N-   : '
	db	'T    : '
	db	'Tau+ : '
	db	'Tau- : '
	db	'Q+   : '
	db	'Q-   : '

NAME_LEN	=	7	;  ப

;----------------------------------------------------------------------------

; 뢠 ਩ 

serialn_out:

	mov	dptr,#SERIALN
	mov	r0,#lcd_buf
	mov	r1,#10

so_next:
	mov	a,#SIGN_SPACE

	jb	MODE_SW,so_write	; ᫨    - 뢮
	jb	RES0,so_write		; ஡

	movc	a,@a+dptr

so_write:
	mov	@r0,a
	inc	r0
	inc	dptr

	djnz	r1,so_next

	mov	flags,#0
	call	display_lcd

	mov	r1,#0
	mov	r2,#0
so_delay:
	djnz	r1,so_delay
	djnz	r2,so_delay

	call	display_lcd

so_exit:
	ret

;----------------------------------------------------------------------------

; ८ࠧ dec_buf -> lcd_buf  ⨥ int_digits

make_lcdq:

	mov	dptr,#tran_table
	mov	r0,#dec_buf
	mov	r1,#lcd_buf
	mov	r2,#10

mlq_next:

	mov	a,#10
	clr	c
	subb	a,r2
	cjne	a,int_digits,mlq_ns

	mov	a,#SIGN_SPACE
	mov	@r1,a
	inc	r1
	jmp	mlq_l

mlq_ns:
	mov	a,@r0
	movc	a,@a+dptr
	mov	@r1,a

	inc	r0
	inc	r1
mlq_l:
	djnz	r2,mlq_next

	ret

;----------------------------------------------------------------------------
;
;dump_decbuf:
;
;	mov	dptr,#tran_table
;	mov	r0,#dec_buf
;	mov	r1,#lcd_buf
;	mov	r2,#10
;
;dd_next:
;
;	mov	a,@r0
;	movc	a,@a+dptr
;	mov	@r1,a
;
;	inc	r0
;	inc	r1
;	djnz	r2,dd_next
;
;	ret
;
;----------------------------------------------------------------------------

;  ਩ 

	org	start+2048-10
	db	SIGN_SPACE	; ' '
	db	SIGN_SPACE	; ' '
	db	SIGN_SPACE	; ' '
	db	SIGN_SPACE	; ' '
	db	0Dh		; 'F'
	db	SIGN_MINUS	; '-'
	db	5		; '0'
	db	5		; '0'
	db	5		; '0'
	db	0Ch		; '3'

;----------------------------------------------------------------------------

	end
